/*
 * #%L
 * OME-XML C++ library for working with OME-XML metadata structures.
 * %%
 * Copyright © 2006 - 2016 Open Microscopy Environment:
 *   - Massachusetts Institute of Technology
 *   - National Institutes of Health
 *   - University of Dundee
 *   - Board of Regents of the University of Wisconsin-Madison
 *   - Glencoe Software, Inc.
 * %%
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 * 1. Redistributions of source code must retain the above copyright notice,
 *    this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDERS OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * The views and conclusions contained in the software and documentation are
 * those of the authors and should not be interpreted as representing official
 * policies, either expressed or implied, of any organization.
 * #L%
 */

/*─────────────────────────────────────────────────────────────────────────────
 *
 * THIS IS AUTOMATICALLY GENERATED CODE.  DO NOT MODIFY.
 *
 *─────────────────────────────────────────────────────────────────────────────
 */

#ifndef OME_XML_MODEL_WELLSAMPLE_H
#define OME_XML_MODEL_WELLSAMPLE_H

#include <algorithm>
#include <list>
#include <stdexcept>
#include <string>
#include <vector>

#include <ome/common/log.h>

#include <ome/common/xml/dom/Document.h>
#include <ome/common/xml/dom/Element.h>
#include <ome/common/xml/dom/Node.h>
#include <ome/common/xml/dom/NodeList.h>

#include <ome/xml/model/Image.h>
#include <ome/xml/model/Well.h>
#include <ome/xml/model/detail/OMEModelObject.h>
#include <ome/xml/model/primitives/NonNegativeInteger.h>
#include <ome/xml/model/primitives/Timestamp.h>

namespace ome
{
  namespace xml
  {
    namespace model
    {

      // Forward declarations.
      class Annotation;
      class OMEModel;
      class PlateAcquisition;

      /**
       * WellSample model object.
       */
      class WellSample : public detail::OMEModelObject
      {
      private:
        class Impl;
        /// Private implementation details.
        ome::compat::shared_ptr<Impl> impl;

      public:
        /// Default constructor.
        WellSample();

        /**
         * Copy constructor.
         *
         * @param copy the WellSample to copy.
         */
        WellSample (const WellSample& copy);

        /// Destructor.
        virtual
        ~WellSample ();

        /**
         * Create a WellSample model object from DOM element.
         *
         * @param element root of the XML DOM tree to from which to
         * construct the model object graph.
         * @param model handler for the OME model used to track
         * instances and references seen during the update.
         * @throws EnumerationException if there is an error
         * instantiating an enumeration during model object creation,
         * or ModelException if there are any consistency or validity
         * errors found during processing.
         *
         * @returns a new model object.
         */
        static ome::compat::shared_ptr< WellSample>
        create(const common::xml::dom::Element& element,
               ome::xml::model::OMEModel& model);

        // Documented in superclass.
        const std::string&
        elementName() const;

        // Documented in superclass.
        bool
        validElementName(const std::string& name) const;


        // -- OMEModelObject API methods --

        /// @copydoc ome::xml::model::OMEModelObject::update
        virtual void
        update(const common::xml::dom::Element&  element,
               ome::xml::model::OMEModel& model);

      public:
        // -- WellSample API methods --

        /// @copydoc ome::xml::model::OMEModelObject::link
        bool
        link (ome::compat::shared_ptr<Reference>& reference,
              ome::compat::shared_ptr< ome::xml::model::OMEModelObject>& object);

        /**
         * Get the Index property.
         *
         * @returns the Index property.
         */
        const ome::xml::model::primitives::NonNegativeInteger&
        getIndex () const;

        /**
         * Set the Index property.
         *
         * @param index the value to set.
         */
        void
        setIndex (const ome::xml::model::primitives::NonNegativeInteger& index);

        /**
         * Get the PositionX property.
         *
         * @returns the PositionX property.
         */
        ome::compat::shared_ptr<double>
        getPositionX ();

        /**
         * Get the PositionX property.
         *
         * @returns the PositionX property.
         */
        const ome::compat::shared_ptr<double>
        getPositionX () const;

        /**
         * Set the PositionX property.
         *
         * @param positionX the value to set.
         */
        void
        setPositionX (ome::compat::shared_ptr<double>& positionX);

        /**
         * Get the PositionY property.
         *
         * @returns the PositionY property.
         */
        ome::compat::shared_ptr<double>
        getPositionY ();

        /**
         * Get the PositionY property.
         *
         * @returns the PositionY property.
         */
        const ome::compat::shared_ptr<double>
        getPositionY () const;

        /**
         * Set the PositionY property.
         *
         * @param positionY the value to set.
         */
        void
        setPositionY (ome::compat::shared_ptr<double>& positionY);

        /**
         * Get the ID property.
         *
         * @returns the ID property.
         */
        const std::string&
        getID () const;

        /**
         * Set the ID property.
         *
         * @param id the value to set.
         */
        void
        setID (const std::string& id);

        /**
         * Get the Timepoint property.
         *
         * @returns the Timepoint property.
         */
        ome::compat::shared_ptr<ome::xml::model::primitives::Timestamp>
        getTimepoint ();

        /**
         * Get the Timepoint property.
         *
         * @returns the Timepoint property.
         */
        const ome::compat::shared_ptr<ome::xml::model::primitives::Timestamp>
        getTimepoint () const;

        /**
         * Set the Timepoint property.
         *
         * @param timepoint the value to set.
         */
        void
        setTimepoint (ome::compat::shared_ptr<ome::xml::model::primitives::Timestamp>& timepoint);

        /**
         * Get linked Image.
         *
         * @returns the linked Image.  The pointer may be
         * null.
         */
        ome::compat::weak_ptr<ome::xml::model::Image>
        getLinkedImage ();

        /**
         * Get linked Image.
         *
         * @returns the linked Image.  The pointer may be
         * null.
         */
        const ome::compat::weak_ptr<ome::xml::model::Image>
        getLinkedImage () const;

        /**
         * Link Image.
         *
         * @param image the Image to link.
         */
        void
        linkImage (ome::compat::shared_ptr<ome::xml::model::Image>& image);

        /**
         * Unlink Image.
         *
         * @param image the Image to unlink.
         *
         * @todo This method is fairly pointless since it's equivalent
         * to linking a null pointer.  It could call @c link(0)
         * internally.
         */
        void
        unlinkImage (ome::compat::shared_ptr<ome::xml::model::Image>& image);

        /**
         * Get size of linked Annotation list.
         *
         * @returns the size of the list.
         */
        OMEModelObject::indexed_container<ome::xml::model::Annotation, ome::compat::weak_ptr>::type::size_type
        sizeOfLinkedAnnotationList () const;

        /**
         * Get the linked Annotation list.
         *
         * @returns a reference to the list.
         */
        OMEModelObject::indexed_container<ome::xml::model::Annotation, ome::compat::weak_ptr>::type
        getLinkedAnnotationList () const;

        /**
         * Get linked Annotation.
         *
         * @param index the index number of the Annotation.
         * @returns a weak pointer to the Annotation.
         * @throws std::out_of_range if the index is invalid.
         */
        const ome::compat::weak_ptr<ome::xml::model::Annotation>&
        getLinkedAnnotation (OMEModelObject::indexed_container<ome::xml::model::Annotation, ome::compat::weak_ptr>::type::size_type index) const;

        /**
         * Set linked Annotation.
         *
         * @note The index must be valid.
         *
         * @param index the index number of the Annotation.
         * @param annotation the Annotation to set.
         * @returns a weak pointer to the Annotation.
         * @throws std::out_of_range if the index is invalid.
         */
        const ome::compat::weak_ptr<ome::xml::model::Annotation>&
        setLinkedAnnotation (OMEModelObject::indexed_container<ome::xml::model::Annotation, ome::compat::weak_ptr>::type::size_type index,
                                     const ome::compat::shared_ptr<ome::xml::model::Annotation>& annotation);

        /**
         * Link Annotation.
         *
         * @param annotation the Annotation to link.
         * @returns @c true if the object was added to the internal
         * annotationLinks list, otherwise @c false.
         *
         * @todo Why have a return value here; what is it used for?
         * Is this an artifact of the Java API?
         */
        bool
        linkAnnotation (const ome::compat::shared_ptr<ome::xml::model::Annotation>& annotation);

        /**
         * Unlink Annotation.
         *
         * @param annotation the Annotation to unlink.
         *
         * @returns @c true if the Annotation was unlinked, otherwise
         * @c false if the Annotation was not linked and could hence not be
         * unlinked.
         *
         * @todo Does the return value serve any useful purpose?  Is
         * this also inherited Java API?
         * @todo Doesn't the removal break the indexing?
         * @todo Does the removal deal with multiple instances; we
         * aren't preventing duplicates on insertion.
         */
        bool
        unlinkAnnotation (const ome::compat::shared_ptr<ome::xml::model::Annotation>& annotation);

        /**
         * Get size of linked PlateAcquisition list.
         *
         * @returns the size of the list.
         */
        OMEModelObject::indexed_container<ome::xml::model::PlateAcquisition, ome::compat::weak_ptr>::type::size_type
        sizeOfLinkedPlateAcquisitionList () const;

        /**
         * Get the linked PlateAcquisition list.
         *
         * @returns a reference to the list.
         */
        OMEModelObject::indexed_container<ome::xml::model::PlateAcquisition, ome::compat::weak_ptr>::type
        getLinkedPlateAcquisitionList () const;

        /**
         * Get linked PlateAcquisition.
         *
         * @param index the index number of the PlateAcquisition.
         * @returns a weak pointer to the PlateAcquisition.
         * @throws std::out_of_range if the index is invalid.
         */
        const ome::compat::weak_ptr<ome::xml::model::PlateAcquisition>&
        getLinkedPlateAcquisition (OMEModelObject::indexed_container<ome::xml::model::PlateAcquisition, ome::compat::weak_ptr>::type::size_type index) const;

        /**
         * Set linked PlateAcquisition.
         *
         * @note The index must be valid.
         *
         * @param index the index number of the PlateAcquisition.
         * @param plateAcquisition_BackReference the PlateAcquisition to set.
         * @returns a weak pointer to the PlateAcquisition.
         * @throws std::out_of_range if the index is invalid.
         */
        const ome::compat::weak_ptr<ome::xml::model::PlateAcquisition>&
        setLinkedPlateAcquisition (OMEModelObject::indexed_container<ome::xml::model::PlateAcquisition, ome::compat::weak_ptr>::type::size_type index,
                                     const ome::compat::shared_ptr<ome::xml::model::PlateAcquisition>& plateAcquisition_BackReference);

        /**
         * Link PlateAcquisition.
         *
         * @param plateAcquisition_BackReference the PlateAcquisition to link.
         * @returns @c true if the object was added to the internal
         * plateAcquisitions list, otherwise @c false.
         *
         * @todo Why have a return value here; what is it used for?
         * Is this an artifact of the Java API?
         */
        bool
        linkPlateAcquisition (const ome::compat::shared_ptr<ome::xml::model::PlateAcquisition>& plateAcquisition_BackReference);

        /**
         * Unlink PlateAcquisition.
         *
         * @param plateAcquisition_BackReference the PlateAcquisition to unlink.
         *
         * @returns @c true if the PlateAcquisition was unlinked, otherwise
         * @c false if the PlateAcquisition was not linked and could hence not be
         * unlinked.
         *
         * @todo Does the return value serve any useful purpose?  Is
         * this also inherited Java API?
         * @todo Doesn't the removal break the indexing?
         * @todo Does the removal deal with multiple instances; we
         * aren't preventing duplicates on insertion.
         */
        bool
        unlinkPlateAcquisition (const ome::compat::shared_ptr<ome::xml::model::PlateAcquisition>& plateAcquisition_BackReference);

        /**
         * Get the Well property.
         *
         * @returns the Well property.
         */
        ome::compat::weak_ptr<ome::xml::model::Well>
        getWell ();

        /**
         * Get the Well property.
         *
         * @returns the Well property.
         */
        const ome::compat::weak_ptr<ome::xml::model::Well>
        getWell () const;

        /**
         * Set the Well property.
         *
         * @param well_BackReference the value to set.
         */
        void
        setWell (ome::compat::weak_ptr<ome::xml::model::Well>& well_BackReference);


        /// @copydoc ome::xml::model::OMEModelObject::asXMLElement
        virtual common::xml::dom::Element
        asXMLElement (common::xml::dom::Document& document) const;


      protected:
        // Documented in base class.
        virtual common::xml::dom::Element
        asXMLElementInternal (common::xml::dom::Document& document,
                              common::xml::dom::Element&  element) const;

      public:
       // Documented in superclass.
       const std::string&
       getXMLNamespace() const;
      };

    }
  }
}

#endif // OME_XML_MODEL_WELLSAMPLE_H

/*
 * Local Variables:
 * mode:C++
 * End:
 */
